#include <dallas/reg320.h>

void init(){
    SCON0 = 0x50;	/* SFR-Serial-Port-0-Control (UserGuide S.31) */
					/* 0x50=01010000							  */
					/* Mode 1, Asynchron, 10 Bit                  */	
					/* Timer 1 Baudrate Generator                 */
						                     
	TMOD  = 0x20;   /* SFR-Timer-Mode-Control (UserGuide S.23)    */
					/* 0x20=00100000                              */
	                /* Timer 1, Mode 2, 8-Bit Auto Reload         */

	TH1   =	0xF3;   /* TH1:  Auto-Reload-Value (UserGuide S.144)  */
					/* for Timer 1 for Baudrate Generation 9600   */
					/* bei Vorteiler 12 und 24 MHz Takt           */

    TR1   = 1;      /* TR1=TCON^6:  Timer 1 starten               */           
					/* TCON: SFR-Timer-Control (UserGuide S.22)   */

    TI    = 1;      /* TI:   set TI to send first char of UART  */          
}


/* Einstellungen für Timer0 und Interupt durchführen */
void init_interrupt(void) {
  	IE = IE | (1<<1);	/* Aktiviere Timer0 Interrupt IE.1 = ET0 = 1*/
  	IE = IE | (1<<7);   /* globales Interrupt enable Bit setzen IE.7 = EA = 1*/

	TMOD = TMOD&0xF0;	/* Bits im Register den Timer0 betreffend zurücksetzten */
	TMOD = TMOD | 1;	/* Timer 0 Mode: (Bit 0 und 1)*/
							// Mode 0: 8 bits with 5-bit prescaler
							// Mode 1: 16 bits
							// Mode 2: 8 bits with auto-reload
							// Mode 3: Timer 0 is two 8 bit counters.

  	//TMOD=TMOD&(~0x04);	/* Timer 0 clock: select internal clock (Bit 3 = 0)*/

  	CKCON = CKCON|0X08;   /* Vorteiler 4  setzen CKCON.3 = T0M = 1
					       	 Vorteiler 12 setzen CKCON.3 = T0M = 0*/

  	//TCON = TCON & (~(1<<5));
  						/* Timer0 Overlowflow TCON.5 = TF0 = 0 */
						/* Bit wird automatisch bei Aufruf von Timer 0 Interrupt rückgesetzt */
  	TCON = TCON | (1<<4); 
						/* Timer0 einschalten TCON.4 = TR0 = 1 */
  }

